package java.game.cars;

import java.util.*;
import java.game.*;
import java.game.parts.*;
import java.game.parts.enginepart.airfueldeliverysystem.*;


public class DBS extends DBS_models
{
	public DBS( int id )
	{
		super( id );
		carCategory = PACKAGE;

		makerName = "Aston Martin";
		model = MODEL_DBS;
		vehicleName = "Aston Martin DBS";
		name = "Aston Martin DBS chassis";

		description = "Vodka, martini. . . Shaken, not Stirred.";

		value = mHUF2USD(15.995);
		brand_new_prestige_value = 845.80;

		fully_stripped_drag = 0.61;

		exhaustSlotIDList = new Vector();
		exhaustSlotIDList.addElement( new Integer(998) );
	}

	public void addStockParts( Descriptor desc )
	{

	// body parts lists //

		// stock 1 stuffs //

		stock_parts_list_E  = new int[27];		
		stock_parts_list_E[ 0] = parts.engines.MC_Prime_SuperDuty:0x00000001r; // "MC GT block" //
		stock_parts_list_E[ 1] = parts.engines.MC_Prime_SuperDuty:0x0000009Br; // "crankshaft bearing" //
		stock_parts_list_E[ 2] = parts.engines.MC_Prime_SuperDuty:0x00000105r; // "MC GTLE crankshaft" //
		stock_parts_list_E[ 3] = parts.engines.MC_Prime_SuperDuty:0x00000106r; // "MC GTLE connecting rods" //
		stock_parts_list_E[ 4] = parts.engines.MC_Prime_SuperDuty:0x00000102r; // "MC GTB GTLE pistons" //
		stock_parts_list_E[ 5] = parts.engines.MC_Prime_SuperDuty:0x000000ADr; // "Hauler Left head" //
		stock_parts_list_E[ 6] = parts.engines.MC_Prime_SuperDuty:0x000000AFr; // "Hauler right head" //
		stock_parts_list_E[ 7] = parts.engines.MC_Prime_SuperDuty:0x00000003r; // "MC GT left exhaust cam" //
		stock_parts_list_E[ 8] = parts.engines.MC_Prime_SuperDuty:0x000000C7r; // "MC GT left intake cam" //
		stock_parts_list_E[ 9] = parts.engines.MC_Prime_SuperDuty:0x000000FCr; // "MC GT right exhaust cam" //
		stock_parts_list_E[ 10] = parts.engines.MC_Prime_SuperDuty:0x000000FDr; // "MC GT right intake cam" //
		stock_parts_list_E[ 11] = parts.engines.MC_Prime_SuperDuty:0x000000BBr; // "l camshaft bearing" //
		stock_parts_list_E[ 12] = parts.engines.MC_Prime_SuperDuty:0x000000BAr; // "r camshaft bearing" //
		stock_parts_list_E[ 13] = parts.engines.MC_Prime_SuperDuty:0x000000BDr; // "l cylinder cover" //
		stock_parts_list_E[ 14] = parts.engines.MC_Prime_SuperDuty:0x000000BCr; // "r cylinder cover" //
		stock_parts_list_E[ 15] = parts.engines.MC_Prime_SuperDuty:0x000000A1r; // "Intake manifold superduty 500" //
		stock_parts_list_E[ 16] = parts.engines.MC_Prime_SuperDuty:0x000000A3r; // "SD500 carbs" //
		stock_parts_list_E[ 17] = parts.engines.MC_Prime_SuperDuty:0x00000097r; // "SD alternator drive belt" //
		stock_parts_list_E[ 18] = parts.engines.MC_Prime_SuperDuty:0x0000009Ar; // "SD camshaft drive belt" //
		stock_parts_list_E[ 19] = parts.engines.MC_Prime_SuperDuty:0x00000100r; // "MC flywheel" //
		stock_parts_list_E[ 20] = parts.engines.MC_Prime_SuperDuty:0x00000103r; // "MC clutch" //
		stock_parts_list_E[ 21] = parts.engines.MC_Prime_SuperDuty:0x00000107r; // "MC GTLE 6speed tranny" //
		stock_parts_list_E[ 22] = parts.engines.MC_Prime_SuperDuty:0x00000095r; // "MC oilpan" //
		stock_parts_list_E[ 23] = parts.engines.MC_Prime_SuperDuty:0x00000096r; // "SD alternator" //
		stock_parts_list_E[ 24] = parts.engines.MC_Prime_SuperDuty:0x000000B0r; // "l exhaust header" //
		stock_parts_list_E[ 25] = parts.engines.MC_Prime_SuperDuty:0x000000B2r; // "r exhaust header" //
		stock_parts_list_E[ 26] = parts:0x000053FFr; // "stock battery" //

		stock_parts_list_FL = new int[1];
		stock_parts_list_FL[ 0] = cars.racers.Aston_DBS:0x000000A1r; // "L headlights" //

		stock_parts_list_FR = new int[1];
		stock_parts_list_FR[ 0] = cars.racers.Aston_DBS:0x0000009Ar; // "R headlights" //

		stock_parts_list_RL = new int[1];
		stock_parts_list_RL[ 0] = cars.racers.Aston_DBS:0x0000009Dr; // "L taillights" //

		stock_parts_list_RR = new int[1];
		stock_parts_list_RR[ 0] = cars.racers.Aston_DBS:0x000000A7r; // "R taillights" //

		stock_parts_list_F  = new int[3];
		stock_parts_list_F[ 0] = cars.racers.Aston_DBS:0x0000009Cr; // "F bumper" //
		stock_parts_list_F[ 1] = cars.racers.Aston_DBS:0x00000092r; // "hood" //
		stock_parts_list_F[ 2] = cars.racers.Aston_DBS:0x000000A2r; // "F windshield" //

		stock_parts_list_Rr = new int[3];
		stock_parts_list_Rr[ 0] = cars.racers.Aston_DBS:0x0000009Fr; // "R bumper" //
		stock_parts_list_Rr[ 1] = cars.racers.Aston_DBS:0x0000009Er; // "trunk" //
		stock_parts_list_Rr[ 2] = cars.racers.Aston_DBS:0x00000094r; // "R windshield" //

		stock_parts_list_L  = new int[3];
		stock_parts_list_L[ 0] = cars.racers.Aston_DBS:0x00000093r; // "FL door" //
		stock_parts_list_L[ 1] = cars.racers.Aston_DBS:0x00000097r; // "FL seat" //
		stock_parts_list_L[ 2] = cars.racers.Aston_DBS:0x00000111r; // "L sideskirt" //

		stock_parts_list_R  = new int[3];
		stock_parts_list_R[ 0] = cars.racers.Aston_DBS:0x000000A6r; // "FR door" //
		stock_parts_list_R[ 1] = cars.racers.Aston_DBS:0x000000AAr; // "FR seat" //
		stock_parts_list_R[ 2] = cars.racers.Aston_DBS:0x00000112r; // "R sideskirt" //

	// running gear parts lists //

		// stock 1 stuffs //

		stock_parts_list_RGear_suspensions = new int[4];
		stock_parts_list_RGear_suspensions[ 0] = parts:0x000001ECr; // "Nonus_SGT_FL_McPherson_strut" //
		stock_parts_list_RGear_suspensions[ 1] = parts:0x000001EDr; // "Nonus_SGT_FR_McPherson_strut" //
		stock_parts_list_RGear_suspensions[ 2] = parts:0x000001EEr; // "Nonus_SGT_RL_trailing_arm" //
		stock_parts_list_RGear_suspensions[ 3] = parts:0x000001EFr; // "Nonus_SGT_RR_trailing_arm" //

		stock_parts_list_RGear_shocks = new int[4];
		stock_parts_list_RGear_shocks[ 0] = stock_parts_list_RGear_shocks[ 1] = parts:0x000001AAr; // "shock_absorber_Nonus_SGT_front" //
		stock_parts_list_RGear_shocks[ 2] = stock_parts_list_RGear_shocks[ 3] = parts:0x000001ACr; // "shock_absorber_Nonus_SGT_rear" //

		stock_parts_list_RGear_springs = new int[4];
		stock_parts_list_RGear_springs[ 0] = stock_parts_list_RGear_springs[ 1] = parts:0x000001D6r; // "spring_Nonus_SGT_front" //
		stock_parts_list_RGear_springs[ 2] = stock_parts_list_RGear_springs[ 3] = parts:0x000001D7r; // "spring_Nonus_SGT_rear" //

		stock_parts_list_RGear_brakes = new int[4];
		stock_parts_list_RGear_brakes[ 0] = stock_parts_list_RGear_brakes[ 1] = parts:0x00000152r; // "brake_Nonus_SGT_front" //
		stock_parts_list_RGear_brakes[ 2] = stock_parts_list_RGear_brakes[ 3] = parts:0x00000153r; // "brake_Nonus_SGT_rear" //

//		stock_parts_list_RGear_sways = new int[2];
//		stock_parts_list_RGear_sways[ 0] = parts:0x0000018Br; // "swaybar_Nonus_SGT_front" //
//		stock_parts_list_RGear_sways[ 1] = parts:0x0000018Cr; // "swaybar_Nonus_SGT_rear" //

		stock_parts_list_RGear_wheels = new int[4];
		stock_parts_list_RGear_wheels[ 0] = stock_parts_list_RGear_wheels[ 1] = cars.racers.Aston_DBS:0x00000A26r; // "Stock_rim" //
		stock_parts_list_RGear_wheels[ 2] = stock_parts_list_RGear_wheels[ 3] = cars.racers.Aston_DBS:0x00000A26r; // "Stock_rim" //

		stock_parts_list_RGear_tyres = new int[4];
		stock_parts_list_RGear_tyres[ 0] = stock_parts_list_RGear_tyres[ 1] = cars.racers.Aston_DBS:0x00000B26r; // "tire" //
		stock_parts_list_RGear_tyres[ 2] = stock_parts_list_RGear_tyres[ 3] = cars.racers.Aston_DBS:0x00000B26r; // "tire" //

		// stage 1 //

		stg_1_rgear_kit_limit = 1.3;

		stg_1_parts_list_RGear_suspensions = new int[4];
		stg_1_parts_list_RGear_suspensions[ 0] = parts:0x000001F0r; // "Nonus_GT2_FL_McPherson_strut" //
		stg_1_parts_list_RGear_suspensions[ 1] = parts:0x000001F1r; // "Nonus_GT2_FR_McPherson_strut" //
		stg_1_parts_list_RGear_suspensions[ 2] = parts:0x000001F2r; // "Nonus_GT2_RL_trailing_arm" //
		stg_1_parts_list_RGear_suspensions[ 3] = parts:0x000001F3r; // "Nonus_GT2_RR_trailing_arm" //

		stg_1_parts_list_RGear_shocks = new int[4];
		stg_1_parts_list_RGear_shocks[ 0] = stg_1_parts_list_RGear_shocks[ 1] = parts:0x000001ADr; // "shock_absorber_Nonus_GT2_front" //
		stg_1_parts_list_RGear_shocks[ 2] = stg_1_parts_list_RGear_shocks[ 3] = parts:0x000001AEr; // "shock_absorber_Nonus_GT2_rear" //

		stg_1_parts_list_RGear_springs = new int[4];
		stg_1_parts_list_RGear_springs[ 0] = stg_1_parts_list_RGear_springs[ 1] = parts:0x000001D8r; // "spring_Nonus_GT2_front" //
		stg_1_parts_list_RGear_springs[ 2] = stg_1_parts_list_RGear_springs[ 3] = parts:0x000001D9r; // "spring_Nonus_GT2_rear" //

		stg_1_parts_list_RGear_brakes = new int[4];
		stg_1_parts_list_RGear_brakes[ 0] = stg_1_parts_list_RGear_brakes[ 1] = parts:0x00000155r; // "brake_Nonus_GT2_front" //
		stg_1_parts_list_RGear_brakes[ 2] = stg_1_parts_list_RGear_brakes[ 3] = parts:0x00000156r; // "brake_Nonus_GT2_rear" //

//		stg_1_parts_list_RGear_sways = new int[2];
//		stg_1_parts_list_RGear_sways[ 0] = parts:0x0000018Dr; // "swaybar_Nonus_GT2_front" //
//		stg_1_parts_list_RGear_sways[ 1] = parts:0x0000018Er; // "swaybar_Nonus_GT2_rear" //

		stg_1_parts_list_RGear_wheels = new int[4];
		stg_1_parts_list_RGear_wheels[ 0] = stg_1_parts_list_RGear_wheels[ 1] = parts.wheels:0x00000400r; // "rim Baiern_DTM 11.0 19 ET -25 LOD CATALOG GARAGE" //
		stg_1_parts_list_RGear_wheels[ 2] = stg_1_parts_list_RGear_wheels[ 3] = parts.wheels:0x00000400r; // "rim Baiern_DTM 11.0 19 ET -25 LOD CATALOG GARAGE" //

		stg_1_parts_list_RGear_tyres = new int[4];
		stg_1_parts_list_RGear_tyres[ 0] = stg_1_parts_list_RGear_tyres[ 1] = parts.wheels:0x00000404r; // "tyre 255 25 19 11.0 LOD CATALOG GARAGE" //
		stg_1_parts_list_RGear_tyres[ 2] = stg_1_parts_list_RGear_tyres[ 3] = parts.wheels:0x00000404r; // "tyre 255 25 19 11.0 LOD CATALOG GARAGE" //

		super.addStockParts( desc );

		addPart( cars.racers.Aston_DBS:0x00000098r, "steering wheel" );

		addPart( cars.racers.Aston_DBS:0x000000E5r, "stock_exhaust_pipe" );
		addPart( parts.mufflers:0x0000001Fr, "muffler type 12" );
		addPart( parts.mufflers:0x0000001Fr, "muffler type 12" );

		if (desc.power > 1.25)
		{
			addPart( parts.wings:0x0000002Ar, "wing" );
		}

		if (desc.power > 1.05 && desc.power < 1.2)
		{
			NOSInjectorSystem N2Oinjector=addPart( parts.engines.Baiern_Emer:0x00000051r, "NOS injector" );
			N2Oinjector.nitro_consumption = clampTo(N2Oinjector.maxconsumption*((desc.power-1.05)/0.15*0.300+0.500),N2Oinjector.minconsumption,N2Oinjector.maxconsumption);
			if (desc.power > 1.1)
			{
				addPart( parts:0x000001C1r, "12pds canister" );
				addPart( parts:0x000001BFr, "24pds canister" );
			}
			else
			{
				addPart( parts:0x000001BFr, "24pds canister" );
			}
		}
		else
		if (desc.power > 1.4)
		{
			NOSInjectorSystem N2Oinjector=addPart( parts.engines.Baiern_Emer:0x00000051r, "NOS injector" );
			N2Oinjector.nitro_consumption = clampTo(N2Oinjector.maxconsumption*((desc.power-1.4)/0.6*0.800+0.200),N2Oinjector.minconsumption,N2Oinjector.maxconsumption);
			addPart( parts:0x000001C1r, "12pds canister" );
			addPart( parts:0x000001BFr, "24pds canister" );
		}
	}
}
